
package com.test.cc;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

@Entity
@Table(name = "GEOGRAPHIC_AREA")
public class GeographicArea {

  @Id
  @GeneratedValue
  private Integer id;

  /// The reference to the top level class.
  @ManyToOne
  @JoinColumn(name = "TOP_LEVEL_ID")
  private TopLevelEntity topLevel;

  // The reference to the shape.
  @OneToOne(cascade = CascadeType.ALL)
  @JoinColumn(name = "SHAPE_ID")
  private ShapeEntity shape;

  public Integer getId() {
      return id;
  }

  public void setId(Integer id) {
      this.id = id;
  }

  public TopLevelEntity getTopLevel() {
      return topLevel;
  }

  public void setTopLevel(TopLevelEntity topLevel) {
      this.topLevel = topLevel;
  }

  public ShapeEntity getShape() {
      return shape;
  }

  public void setShape(ShapeEntity shape) {
      this.shape = shape;
  }
}
