/*
 * Hibernate, Relational Persistence for Idiomatic Java
 *
 * License: GNU Lesser General Public License (LGPL), version 2.1 or later. See the lgpl.txt file in
 * the root directory or <http://www.gnu.org/licenses/lgpl-2.1.html>.
 */
package com.test.cc;

import javax.inject.Inject;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.TestExecutionListeners;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.support.DependencyInjectionTestExecutionListener;
import org.springframework.test.context.transaction.TransactionConfiguration;
import org.springframework.test.context.transaction.TransactionalTestExecutionListener;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration("classpath:inheritanceSecondaryTableTestBeans.xml")
@TestExecutionListeners({DependencyInjectionTestExecutionListener.class,
    TransactionalTestExecutionListener.class})
@TransactionConfiguration(transactionManager = "transactionManager", defaultRollback = false)
public class InheritanceSecondaryTableTest51Reworked {

  @Inject
  private transient TopLevelRepository repository;

  @Test
  public void testInheritanceWithSecondaryTable1() {

    final TopLevelEntity top = new TopLevelEntity();

    final GeographicArea area1 = new GeographicArea();
    area1.setTopLevel(top);
    area1.setShape(new ShapePolygonEntity());
    top.getGeographicAreas().add(area1);

    final ShapeCircleEntity circle = new ShapeCircleEntity();
    circle.setCentre("CENTRE");

    final GeographicArea area2 = new GeographicArea();
    area2.setTopLevel(top);
    area2.setShape(circle);
    top.getGeographicAreas().add(area2);

    repository.saveAndFlush(top);
  }

}
